///////////////////////////////////////////////////////////////////////////////
//Schnittmenge der Horseshoe-Map vorwärts und rückwärts zur Visualisierung
//einer fraktalen Cantor-Menge bis etwa 5.Iteration
//////////////////////////////////////////////////////////////////////////////

int a = 900 ;//Bildbreite/höhe
float x,y;//Hilfsvariable
float xAlt,yAlt,xNeu,yNeu;//Iterationsvariable
int xAltK, yAltK;
int anzahlItAkt = 0;//zum zählen der Iterationen
int anzahlIt = 1;//Anzahl der Iterationen
int anzahlStartP = 10000;//Anzahl der Startpunkte

float yUMap, yOMap; //Zu zeichnender y-Bereich
float xUMap, xOMap; //Zu zeichnender x-Bereich
color bildMatrix[][]; // = new color[a][a];
color rot = color(255,0 , 0);
color gelb = color(255,255,0);
color schwarz = color(0);


////////////////////////////////////////////////////////////////
void setup(){
  size(900,900);   
   xUMap = 0;
   xOMap = a;
   yUMap = 0;
   yOMap = a;
   bildMatrix  = new color[a][a];
   matrixInitialisieren();
   
   abbilden();
}
///////////////////////////////////////////////////////////////////
void matrixInitialisieren(){
  for(int i =0; i<a;i++){
     for(int j =0; j<a;j++){
        bildMatrix[i][j] = schwarz;
     }
  }
}
//////////////////////////////////////////////////////////////////
void draw(){
 
//braucht man für Mausklicks...   
}


/////////////////////////////////////////////////////

void abbilden(){

 background(0);
  smooth();
  textSize(12);
  x = 0; y=0;//initialisieren
 
  for(int i=0; i<anzahlStartP;i++){
    xAlt = random(0,a);
    yAlt = random(0,a);
    hufeisenAbbVorwaerts(xAlt,yAlt);
  }  
  for(int i=0; i<anzahlStartP;i++){
    xAlt = random(0,a);
    yAlt = random(0,a);
    hufeisenAbbRueckwaerts(xAlt,yAlt);
  }     
  schnittmengeZeichnen();
 
}
///////////////////////////////////////////////////
void hufeisenAbbVorwaerts(float x, float y){
   this.x =x;
   this.y =y;
   
   strokeWeight(1);
        
   xAlt = x;  
   yAlt = y;
   anzahlItAkt =0;
   iterierenVorwaerts();    
  
}
////////////////////////////////////////////////////////////
void hufeisenAbbRueckwaerts(float x, float y){
   this.x =x;
   this.y =y;
   //stroke(255);
   strokeWeight(1);
        
   xAlt = x;  
   yAlt = y;
   anzahlItAkt =0;
   iterierenRueckwaerts();    
  
}


////////////////////////////////////////////////////////////
void iterierenVorwaerts(){
   
   if(xAlt <a/3){
      
         xNeu = 3*xAlt;
         yNeu = yAlt/3;     
         xAlt = xNeu;
         yAlt = yNeu;
        
         anzahlItAkt++;   
        if(anzahlItAkt <anzahlIt ) {
             
            iterierenVorwaerts();          
         }else{  
           yAltK = int(round(yAlt)); 
           if(yAltK <  0) yAltK = 0;
           if(yAltK >= a) yAltK = a-1;
           for(int i =0; i<a;i++){
             bildMatrix[i][yAltK] = rot;
           }
         }
           
       } else  if(xAlt >2*a/3){
    
         xNeu = 3*a-3*xAlt;
         yNeu = a-yAlt/3;      
         xAlt = xNeu;
         yAlt = yNeu;
      
         anzahlItAkt++;          
         if(anzahlItAkt <anzahlIt) {
            
            iterierenVorwaerts();          
         }else {
            yAltK = int(round(yAlt)); 
           if(yAltK <  0) yAltK = 0;
           if(yAltK >= a) yAltK = a-1;       
           for(int i =0; i<a;i++){
              bildMatrix[i][yAltK] = rot;
           }
         }    
      }
}
///////////////////////////////////////////////////////////////////////
void iterierenRueckwaerts(){
  
   if(yAlt <a/3){
      
         xNeu = xAlt/3;
         yNeu = 3*yAlt;     
         xAlt = xNeu;
         yAlt = yNeu;
        
         anzahlItAkt++;   
        if(anzahlItAkt <anzahlIt ) {
             
            iterierenRueckwaerts();          
         }else{
            xAltK = int(round(xAlt)); 
           if(xAltK < 0) xAltK = 0;
           if(xAltK >= a) xAltK = a-1;
           yAltK = int(round(yAlt)); 
           if(yAltK <  0) yAltK = 0;
           if(yAltK >= a) yAltK = a-1;
           
         //  if(bildMatrix[xAltK][yAltK] == rot){
             
           for(int j =0; j<a;j++){
             if(bildMatrix[xAltK][j] == rot)
              bildMatrix[xAltK][j] = gelb;
           }
           //  bildMatrix[xAltK][yAltK] = gelb;
          // }
          
           }         
       }
    else if(yAlt >2*a/3){
     
         xNeu = a-xAlt/3;
         yNeu = 3*a-3*yAlt;      
         xAlt = xNeu;
         yAlt = yNeu;
         
         anzahlItAkt++;          
         if(anzahlItAkt <anzahlIt) {
           
            iterierenRueckwaerts();          
         }else{
           
        
           xAltK = int(round(xAlt)); 
           if(xAltK < 0) xAltK = 0;
           if(xAltK >= a) xAltK = a-1;
           yAltK = int(round(yAlt)); 
           if(yAltK <  0) yAltK = 0;
           if(yAltK >= a) yAltK = a-1;
           stroke(gelb);
         //  if(bildMatrix[xAltK][yAltK] == rot){
               
               for(int j =0; j<a;j++){
                 if(bildMatrix[xAltK][j] == rot)
                  bildMatrix[xAltK][j] = gelb;
               }
             //  bildMatrix[xAltK][yAltK] = gelb;
          // }           
        } 
    }
}
//////////////////////////////////////////////////////////////////
void schnittmengeZeichnen(){

  strokeWeight(1);
  
  stroke(0);
   for(int j=0;j<a;j++){
     for(int i=0; i<a;i++){
       if( bildMatrix[i][j] == rot){
          stroke(schwarz);
          point(i,j);
         
       }
       if( bildMatrix[i][j] == gelb){
          stroke(gelb);
          point(i,j);
         
       }
     }
   }
}
//////////////////////////////////////////////////////

void mousePressed() { 
  if(mouseButton == LEFT){//nächste Iteration
      anzahlIt++;  
      matrixInitialisieren();
      abbilden();
  }
  if(mouseButton == RIGHT){//Mit Faktor 2 zoomen
     a= a*2;
     bildMatrix  = new color[a][a];
     matrixInitialisieren();
     anzahlStartP = anzahlStartP*5;
      abbilden();
  }  
}
